"use strict";
this.name	= "thecollector";
this.author	= "mossfoot, Norby";
this.copyright	= "2014 Norby";
this.description= "Missions from The Collector";
this.version	= "0.1";
this.licence	= "CC BY-NC-SA 4.0";


//internal properties, should not touch
this.$TheCollectorMissionStage = 0; //Where the player stay in the missions
this.$TheCollectorMissionStartTime = null; //When the current mission started
this.$TheCollectorMissionSub = null; //Where the player stay within a MissionStage
this.$TheCollectorMSO = true; //flag for the first missionScreenOpportunity after landing
this.$TheCollectorStation = null; //store the station to detect if spawned
this.$TheCollectorStationKey = "thecollector_adck_coriolis-station"; //dataKey of collector's station

//worldscript events
this.startUp = function() {
	this.$TheCollectorMissionStage = missionVariables.$TheCollectorMissionStage;
	if(!(this.$TheCollectorMissionStage)) this.$TheCollectorMissionStage = 0;
	if(this.$TheCollectorMissionStage > 0) this.$TheCollectorInstructions(false); //set the F5F5 info
	this.$TheCollectorMissionStartTime = missionVariables.$TheCollectorMissionStartTime;

	this.$TheCollectorSound1 = new SoundSource;
	if( worldScripts["BGS-M"] ) this.$TheCollectorSound1.sound = "bgs-c_buy.ogg";
	else this.$TheCollectorSound1.sound = "buy.ogg";
	this.$TheCollectorSound1.loop = false;
	this.$TheCollectorSound1.repeatCount = 1;
}

this.systemWillPopulate = function() { //for Oolite 1.79 and above
	if( galaxyNumber == 0 && system && system.ID == 119 && !this.$TheCollectorStation ) {
		var ppos = system.mainPlanet.position; //main planet position
		var psvector = system.sun.position.subtract(ppos); //planet to sun vector
		var psdistance = ppos.distanceTo(system.sun.position); //planet to sun distance
		var spos = ppos.add( psvector.direction().multiply( psdistance / 4 )); //station position
		system.setPopulator("thecollector_station", {
			callback: function(pos) {
				var s = system.addShips("[" + this.$TheCollectorStationKey + "]", 1, spos, 0);
				if(s) this.$TheCollectorStation = s[0];
			}.bind(this),
			location: "COORDINATES",
			coordinates: spos,
			deterministic: true
		});

		system.setPopulator("thecollector_asteroids", {
			callback: function(pos) {
				system.addShips("asteroid", 50, spos, 50000);
			}.bind(this),
			location: "COORDINATES",
			coordinates: spos
		});
	}
}

this.missionScreenOpportunity = function() {
	var p = player.ship;
//	log(this.name, p.dockedStation);//debug
	if( p && p.docked && galaxyNumber == 0 && this.$TheCollectorMSO ) {
		this.$TheCollectorMSO = false; //only in the first missionScreenOpportunity after landing
		if( system && p.dockedStation == system.mainStation ) {
			if( system.ID == 119 && this.$TheCollectorMissionStage < 4 //Rarere
				&& p.dockedStation.dataKey != this.$TheCollectorStationKey ) {
				this.$TheCollectorMissionStage = 3; //local rumor until stage 4
				this.$TheCollectorInstructions(true);
			} else if( system.ID == 160 && this.$TheCollectorMissionStage == 5 ) { //Leritean
				this.$TheCollectorMissionStage = 6;//todo
				this.$TheCollectorInstructions(true);
			} else if( system.ID == 65 && this.$TheCollectorMissionStage < -1 ) { //Sori
				this.$TheCollectorMissionStage = -1;//todo: a ship is delivered
				this.$TheCollectorInstructions(true);
			} else if( system.ID == 66 && this.$TheCollectorMissionStage < -1 ) { //Aate
				this.$TheCollectorMissionStage = -1;//todo: a ship is delivered
				this.$TheCollectorInstructions(true);
			} else if( this.$TheCollectorMissionStage < 2 && Math.random() < 0.1 ) { //10% chance
				this.$TheCollectorMissionStage = 1; //galaxy hint talk until stage 2
				this.$TheCollectorInstructions(true);
			}
		} else if(p.dockedStation.dataKey == this.$TheCollectorStationKey ) {
			if( this.$TheCollectorMissionStage < 5 ) { //offer Leritean mission
				this.$TheCollectorMissionStage = 4;
				this.$TheCollectorInstructions(true);
				
			}
/*			if( this.$TheCollectorMissionStage == 6 ) { //arrived back to the collector from Leritean
				this.$TheCollectorMissionStage = 7;
				this.$TheCollectorInstructions(true);
				
			}
*/		}
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$TheCollectorMissionStage = this.$TheCollectorMissionStage;
	missionVariables.$TheCollectorMissionStartTime = this.$TheCollectorMissionStartTime;
}

this.shipWillDockWithStation = function(station) {
	this.$TheCollectorMSO = true; //flag for the first missionScreenOpportunity after landing
}

this.shipWillEnterWitchspace = function() {
	this.$TheCollectorStation = null; //clear the station storage
}

this.shipWillExitWitchspace = function() { //use this event due to shipExitedWitchspace is not working in v1.77
	this.$TheCollectorCreateStation();
}

this.shipWillLaunchFromStation = function(station) {
	this.$TheCollectorCreateStation();
}

//TheCollector methods
this.$TheCollectorCreateStation = function() { //for Oolite v1.77 only
	if( galaxyNumber == 0 && system && system.ID == 119 && !this.$TheCollectorStation ) {
		var ppos = system.mainPlanet.position; //main planet position
		var psvector = system.sun.position.subtract(ppos); //planet to sun vector
		var psdistance = ppos.distanceTo(system.sun.position); //planet to sun distance
		var spos = ppos.add( psvector.direction().multiply( psdistance / 4 )); //station position
		var s = system.addShips("[" + this.$TheCollectorStationKey + "]", 1, spos, 0);
		if(s) this.$TheCollectorStation = s[0];
		system.addShips("asteroid", 50, spos, 50000);
	}
}

this.$TheCollectorInstructions = function(mscreen) {
	var t = worldScripts.thecollector;
	if(mscreen) { //display missionscreen
		t.$TheCollectorMissionSub = "_"; //start
		t.$TheCollectorMissionScreen(t);
		if(msg) player.commsMessage(msg, 10);
	}
	var msg = expandMissionText(t.name+t.$TheCollectorMissionStage);
	if(msg) {
		mission.setInstructions( msg+" (#"+t.$TheCollectorMissionStage+")", t.name);//show in F5-F5 screen
		t.$TheCollectorMissionStartTime = clock.seconds;
	}
}

this.$TheCollectorMissionScreen = function( t ) {
	var mt = t.$TheCollectorMissionStage+t.$TheCollectorMissionSub;
	var todo = expandMissionText(t.name+t.$TheCollectorMissionStage);
	var m = expandMissionText(t.name+mt, {thecollectortodo: todo});
	if( !m || !(m.length>0) ) return;
	var c = [];
	var cr = 0;
	for( var j = 1; j < 10; j++ ) {
		var mj = t.name+mt+j;
		var txt = null;
		cr = expandMissionText(mj+"cr"); //must pay for this choice?
		if( !cr || !(cr>0) || player.credits >= cr ) //do not show if not enough money
			txt = expandMissionText(mj);
		if( txt && txt.length > 0 ) c[ j ] = txt;
	}
	if( c.length < 1 ) c[0] = "OK"; //default choice if none is defined
//	log(t.name, "Stage #"+mt+" c.length: "+c.length+" "+c[0]);//debug
	mission.runScreen({
			title: "The Collector (#"+t.$TheCollectorMissionStage+")",
			message: m,
			background: "thecollector_background.png",
			exitScreen: "GUI_SCREEN_MANIFEST",
			choices: { "_0" : c[0],
				"_1" : c[1],
				"_2" : c[2],
				"_3" : c[3],
				"_4" : c[4],
				"_5" : c[5],
				"_6" : c[6],
				"_7" : c[7],
				"_8" : c[8],
				"_9" : c[9]
			}
	},function( choice ) {
			var o = 0;
			if( choice ) o = choice.substr(1); //cut starting "_"
			var cr = expandMissionText(t.name+mt+o+"cr"); //must pay for this choice?
			var r = expandMissionText(t.name+mt+o+"redir");
			var redir = false;
			if( r && r.length > 0 ) {
				redir = true;
				if( 1*r == r ) { //redir to a single number mean new stage
					t.$TheCollectorMissionStage = r;
					t.$TheCollectorInstructions(false);
					t.$TheCollectorMissionSub = "_"; //begin of a new stage
				} else if( r.indexOf("_") == 0 ) { //redir begin with underscore mean new sub within this stage
					t.$TheCollectorMissionSub = r + "_";
				} else { //redir into a new stage lower than the first subpage
					var i = r.indexOf("_");
					t.$TheCollectorMissionStage = r.substr(0, i);
					t.$TheCollectorInstructions(false);
					t.$TheCollectorMissionSub = r.substr(i) + "_";
//		   			log(t.name, r+" "+t.$TheCollectorMissionStage+" "+t.$TheCollectorMissionSub);//debug
				}
			}
   			log(t.name, "Stage:"+mt+" choice:"+o+" "+c[o]+" cr:"+cr+" redir:"+r);//debug
			if( o > 0 ) {
				if( cr > 0 ) { //must pay for this choice!
					player.credits -= cr;
					t.$TheCollectorSound1.play();
				}
				if( !redir ) t.$TheCollectorMissionSub += o + "_";
				t.$TheCollectorMissionScreen(t); //recursive, so do not use too much level
			} else return; //exit
//			if( !isValidFrameCallback( h.$HUDSelectorFCB2 ) )
//				h.$HUDSelectorFCB2 = addFrameCallback( h.$HUDSelector_FCB2 );
 	});
}
